#include "stm32f4xx.h"
#include "usart.h"
#include "delay.h"
#include "ch395.h"
#include "ch395inc.h"
#include "CH395_network_operation.h"
#include "CH395_interface_operation.h"
#include "MCU_communication_interface.h"


/* IP */
const uint8_t local_ip[4] = {192,168,2,200};                   /* CH395IPַ */
const uint8_t gateway_ip[4] = {192,168,2,1};                   /* CH395 */
const uint8_t mask_ip[4] = {255,255,255,0};                     /* CH395 */

/* TCP_Clientض */
const uint8_t  Socket0DesIP[4] = {192,168,2,100};                /* Socket 0ĿIPַ */
const uint16_t Socket0DesPort = 6000;                           /* Socket 0ĿĶ˿ */
const uint16_t Socket0SourPort = 5000;                          /* Socket 0Դ˿ */

/* ñ */
struct   _SOCK_INF sockinf[4];                                  /* SocketϢ */
struct   _CH395_SYS  CH395Inf;                                  /* CH395Ϣ */
uint8_t  socket_buff[4][1024];                                  /* ݻ */

/* Global Variable */ 
void CH395GlobalInterrupt(void);
void CH395SocketInterrupt(uint8_t sockindex);



int main(void)
{
	uint8_t rc;
	delay_init(168);
	uart_init(921600);
	
  printf("This is CH395 paralell interface demo\r\n");
	
  CH395_if_init();                             /* CH32F103ƽӿڳʼ */
	ch395_inf_init();                            /* CH395Ϣʼ */
	ch395_cmd_hard_reset();
	delay_ms(500);
	
	rc=CH395_init();                             /* CH395óʼ */
  stop_if_error(rc);                           /*  */
	
	Socket_R_S_Buf_Modify();                     /* ·仺ʹ8socket±뾭˲ */
	ch395_set_tcpmss(default_tcp_mss);           /* ¶TCP MSS */
	
  while(1)
  {                                                                 /* ȴ̫ӳɹ*/
     if(ch395_cmd_get_phy_status() == PHY_DISCONN)                     /* ѯCH395Ƿ */
     {
        delay_ms(200);                                            /* δȴ200MSٴβѯ */
     }
     else 
     {
         printf("CH395 Connect Ethernet\r\n");                       /* CH395оƬӵ̫ʱж */
         break;
     }
  }
	
	ch395_socket_init();                         /* socketϢʼ */
	socket_open();                               /* socket */

	while(1)
	{
		if(ch395_exti_stat==0)
		{
		  CH395GlobalInterrupt();
		}
	}
}


/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindexsocket
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(uint8_t sockindex)
{
   uint8_t  sock_int_socket;
   uint16_t len;
   uint16_t tmp;

   sock_int_socket = ch395_get_socket_int(sockindex);                /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
	   delay_us(300);
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
//	   printf("send ok!\n");
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
     len = ch395_get_recv_length(sockindex);                        /* ȡǰݳ */
	   printf("receive len = %d\n",len);
		 delay_us(200);
	   if(len == 0)return;
     if(len > default_tcp_mss)len = default_tcp_mss;                /* MyBufferΪ512*/
	   ch395_get_recv_data(sockindex,len,socket_buff[sockindex]);     /* ȡ */
     ch395_send_data(sockindex,socket_buff[sockindex],len);
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                           /* жϣTCPģʽЧ*/
   {
	   uint8_t target_inf[6];
	   printf("SINT_STAT_CONNECT\r\n");
       if(sockinf[sockindex].TcpMode == TCP_SERVER_MODE)             /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
       {
           ch395_cmd_get_remoteipp(sockindex,target_inf);
           tmp = (uint16_t)(target_inf[5]<<8) + target_inf[4];
           printf("IP address = %d.%d.%d.%d\n",(uint16_t)target_inf[0],(uint16_t)target_inf[1],(uint16_t)target_inf[2],(uint16_t)target_inf[3]);    
           printf("Port = %d\n",tmp);    
       }
   }
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
   /*SOCK_CTRL_FLAG_SOCKET_CLOSEλжҪرSocketٽλҪCH395CloseSocketCH395ڲѾرա*/
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
	   printf("SINT_STAT_DISCONNECT\r\n");
   }
	if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
	{
		printf("SINT_STAT_TIM_OUT\r\n");
	}
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
	uint16_t  init_status,tem_flag;
	uint8_t  i,buf[10]; 

	init_status = ch395_cmd_get_glob_int_status_all();
	if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
	{
		ch395_cmd_get_unreachippt(buf);                                
	}
	if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
	{
	}
	if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
	{
		printf("Init status : GINT_STAT_PHY_CHANGE\r\n");
	}

	tem_flag=GINT_STAT_SOCK0;
	for(i=0;i<8;i++)
	{
		if(init_status & tem_flag)
		   CH395SocketInterrupt(i);   
		tem_flag=(1<<(4+1+i));
	}
}





